program servicios;
{$APPTYPE CONSOLE}
uses
  WinSvc,
  types,
  windows;

//para quitar -  /
function parametro(Opc: Char): Boolean;
var
  x : Integer;
begin
  Result := False;
  for x := 1 to ParamCount do
    if (ParamStr(x) = '-' + opc) or (ParamStr(x) = '/' + opc) then
      Result := True;
end;

{sc-----------------------------------------------------------------------
  ServiceStart

  sMachine:
     machine name, ie: \\SERVER
     empty = local machine

  Purpose:
     start service
     return TRUE if successful
-----------------------------------------------------------------------sc}
function ServiceStart(sMachine, sService: String) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  psTemp: PChar;
  dwChkP: DWord;
begin
  ss.dwCurrentState := 0;
  schm := OpenSCManager(PChar(sMachine), nil, SC_MANAGER_CONNECT);
  if (schm>0) then
  begin
    schs := OpenService(schm, PChar(sService), SERVICE_START or
      SERVICE_QUERY_STATUS);
    if (schs>0) then
    begin
      psTemp := nil;
      if (StartService(schs, 0, psTemp)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_RUNNING<>ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_RUNNING=ss.dwCurrentState;
end;


{sc-----------------------------------------------------------------------
  ServiceStop

  Purpose:
   stop a service, parameters as in ServiceStart
-----------------------------------------------------------------------sc}
function ServiceStop(sMachine, sService: String) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  dwChkP: DWord;
begin
  schm := OpenSCManager(PChar(sMachine), nil, SC_MANAGER_CONNECT);
  if (schm>0) then
  begin
    schs := OpenService(schm, PChar(sService), SERVICE_STOP or
      SERVICE_QUERY_STATUS);
    if (schs>0) then
    begin
      if (ControlService(schs, SERVICE_CONTROL_STOP, ss)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_STOPPED<>ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_STOPPED=ss.dwCurrentState;
end;


begin
  Writeln('AjpdSoft IDServicios v1.0');
  Writeln('2003 AjpdSoft. Todos los derechos reservados.');
  Writeln('http://www.ajpdsoft.com');
  Writeln('');
  if (parametro('?')) or (parametro('h')) or (parametro('a')) or (ParamCount <> 3) then
  begin
    Writeln('Uso del comando: servicios [-id] NombreEquipo NombreServicio');
    Writeln('        -i:      inicia el servicio pasado como parametro (NombreServicio).');
    Writeln('        -d:      detiene el servicio pasado como parametro (NombreServicio).');
    Writeln('');
    Writeln('NOTA: no se adminten espacios en blanco en el Nombre del Servicio ni en el Nombre del Equipo.');
    Writeln('');
    Writeln('Ejemplo:');
    Writeln('  Para iniciar el servicio: "Actualizacioens automaticas" en el PCServidor:');
    Writeln('    servicios -i pcservidor wuauserv');
  end
  else
  begin
    if (parametro('i')) then
    begin
      if (ServiceStart('\\' + ParamStr(2), ParamStr(3))) then
        Writeln ('El Servicio se ha iniciado correctamente.')
      else
        Writeln ('El Servicio NO se ha iniciado.');
    end;
    if (parametro('d')) then
    begin
      if (ServiceStop('\\' + ParamStr(2), ParamStr(3))) then
        Writeln ('El Servicio se ha detenido correctamente.')
      else
        Writeln ('El Servicio NO se ha detenido.');
    end;
  end;
end.
